import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.stream.Stream;

public class Arraz {

    public int sumValuesOfArray(int[] intArr){
        int sum = 0;
        for (int i:intArr) {
            sum += i;
        }
        return sum;
    }

    public double sumDoublesOfArray(double[] doublesArr){
        double sum = 0;
        for (double i:doublesArr) {
            sum += i;
        }
        return sum;
    }

    public int averageOfArray(int[] intArr){
        int sum = sumValuesOfArray(intArr);
        return sum / intArr.length;
    }

    public double doubleAverageOfArray(double[] doublesArr){
        double sum = sumDoublesOfArray(doublesArr);
        return sum / doublesArr.length;
    }

    public boolean containsValue(int[] intsArr, int findThisInt){
        boolean retBoolean = false;
        for (int i:intsArr) {
            if (i == findThisInt){
                retBoolean = true;
                break;
            }
        }
        return retBoolean;
    }

    public int[] reverseArray(int[] intsArr){
        int[] retArr = new int[intsArr.length];
        int counter = intsArr.length - 1;

        for (int i:intsArr) {
            retArr[counter] = i;
            counter--;
        }

        return retArr;
    }

    public OddEven getOddEvensOfArray(int[] intsArr){
        OddEven oddEven = new OddEven();
        oddEven.evens = 0;
        oddEven.odds = 0;

        for (int i:intsArr) {
            if(i % 2 == 0){
                oddEven.evens++;
            } else {
                oddEven.odds++;
            }
        }
        return oddEven;
    }

    public int findIndexOf(int[] intsArr, int index){
        return intsArr[index];
    }


//    public Integer[] copyArrayByIterator(Integer[] intInput) {
//        Integer[] retArr = new Integer[intInput.length];
//
//        Iterator<Integer> iterator = new Iterator<Integer>() {
//            public boolean hasNext(int intValue) {
//                return intValue == null ? true : false;
//            }
//
//            public Integer next() {
//                return null;
//            }
//
//            public void remove() {
//
//            }
//        }
//        return retArr;
//    }

    public int[] copyArrayByLoop(int[] ints){
        int[] retArr = new int[ints.length];
        for (int i = 0; i < ints.length; i++) {
            retArr[i] = ints[i];
        }
        return retArr;
    }

    public int[] removeElementFromArray(int[] ints, int removeInt){
        int[] retArr = new int[ints.length - 1];

        int index = 0;
        for (int i:ints) {
            if (i != removeInt){
                retArr[index] = i;
                index++;
            }
        }
        return retArr;
    }

    public int[] insertIntoArrayAt(int[] ints, int index, int intToInsert){
        int[] retArr = new int[ints.length + 1];

        int intsIndex = 0;
        for (int i = 0; i < retArr.length; i++){
            if (i == index){
                retArr[i] = intToInsert;
            }
            else {
                retArr[i] = ints[intsIndex];
                intsIndex++;
            }
        }
        return retArr;
    }

    public MaxMin findMaxMinOfArray(int[] ints){
        MaxMin maxMin = new MaxMin();
        int minVal = Integer.MAX_VALUE;
        int maxVal = Integer.MIN_VALUE;

        for (int i:ints) {
            if (i < minVal){
                minVal = i;
            }
            if (i > maxVal){
                maxVal = i;
            }
        }

        maxMin.min = minVal;
        maxMin.max = maxVal;
        return maxMin;
    }

    public int[] removeDupesFromArray(int[] ints){
        ArrayList<Integer> retArr = new ArrayList();
        retArr.add(ints[0]);

        for (int i = 1; i < ints.length; i++) {
            if (!retArr.contains(ints[i])){
                retArr.add(ints[i]);
            }
        }
        int[] intsToRet = new int[retArr.size()];

        int counter = 0;
        for (int i:retArr) {
            intsToRet[counter] = i;
            counter++;
        }
        return intsToRet;
    }

}
